import { BrowserModule } from "@angular/platform-browser";
import { BrowserAnimationsModule } from "@angular/platform-browser/animations";
import { NgModule, CUSTOM_ELEMENTS_SCHEMA, APP_INITIALIZER } from "@angular/core";
import { FormsModule, ReactiveFormsModule } from "@angular/forms";
import { HttpClientModule, HTTP_INTERCEPTORS } from "@angular/common/http";
import {
  RouterModule,
  ActivatedRouteSnapshot,
  RouterStateSnapshot
} from "@angular/router";
import { MatDialogModule } from "@angular/material/dialog";
import { AppDxtremeModule } from "./app-dxtreme.module"; //Added by Tony - Decluttering
import { AppMaterialModule } from "./app-material.module"; //Added by Tony - Decluttering

// import Components
import {
  AppComponent,
  NavMenuComponent,
  NavHeaderComponent,
  NavFooterComponent,
  NavLinksComponent,
  SideNavComponent,
  HomeComponent,
  UserComponent,
  NRMBPMInterfaceViewComponent,
  PeopleSoftInterfaceViewComponent,
  DedicatedCustomerComponent,
  EventTypeComponent,
  SearchComponent,
  AdvancedSearchComponent,
  SearchResultComponent,
  MDSMACActivityComponent,
  AuthorizeComponent,
  ServiceDeliveryComponent,
  SprintHolidayComponent,
  ServiceAssuranceSiteSupportComponent,
  SpecialProjectComponent,
  TelcoComponent,
  MDS3rdPartyServiceComponent,
  MDS3rdPartyVendorComponent,
  ServiceTierComponent,
  EnhncSrvcComponent,
  ManageUsersComponent,
  XnciMsSlaComponent,
  CurrencyListComponent,
  UnlockItemsComponent,
  WorldHolidayComponent,
  CancelOrdrComponent,
  SetPreferenceComponent,
  FastTrackAvailabilityComponent,
  VendorManagementComponent,
  EventIntervalComponent,
  VendorModelComponent,
  FedlineAvailabilityComponent,
  XnciRegionComponent,
  CCDBypassComponent,
  CcdChangeComponent,
  CurrencyFileComponent,
  CustomerUserProfileComponent,
  UcaasComponent,
  AccessDeliveryComponent,
  AccessDeliveryFormComponent,
  SiptComponent,
  SiptFormComponent,
  SorryComponent,
  UserFinderComponent,
  QualificationComponent,
  QualificationFormComponent,
  QualificationViewComponent,
  SampleEventComponent,
  FedlineComponent,
  MdsComponent,
  MplsComponent,
  MplsFormComponent,
  NgvnComponent,
  SprintLinkComponent,
  SprintLinkFormComponent,
  CreateViewComponent,
  FedlineFormComponent,
  MdsFormComponent,
  NgvnFormComponent,
  UcaasFormComponent,
  WfCalendarComponent,
  SprintLinkCalendarComponent,
  NccoOrderFormComponent,
  NccoOrderComponent,
  MssViewEngagementsComponent,
  MssProductTypesComponent,
  ViewRedesignComponent,
  NewRedesignComponent,
  CustomerBypassComponent,
  NgvnCalendarComponent,
  MssNewEngagementComponent,
  ADBroadbandCalendarComponent,
  ADNarrowbandCalendarComponent,
  ADGovernmentCalendarComponent,
  ADInternationalCalendarComponent,
  ADTMTCalendarComponent,
  ESCalendarComponent,
  SiptCalendarComponent,
  UCaaSCalendarComponent,
  MplsVasCalendarComponent,
  MplsCalendarComponent,
  MdsftCalendarComponent,
  MdsCalendarComponent,
  NetworkIntlCalendarComponent,
  CpeClliComponent,
  CpeClliFormComponent,
  CptAssignmentComponent,
  CptFormComponent,
  CptReportComponent,
  CptReturnComponent,
  CptSearchComponent,
  CptViewComponent,
  FedlineCalendarComponent,
  ADBroadbandListViewComponent,
  ADGovernmentListViewComponent,
  ADInternationalListViewComponent,
  ADNarrowbandListViewComponent,
  ADTMTListViewComponent,
  ESListViewComponent,
  FedlineListViewComponent,
  MdsListViewComponent,
  MdsftListViewComponent,
  NetworkIntlListViewComponent,
  MplsListViewComponent,
  MplsVasListViewComponent,
  NgvnListViewComponent,
  SiptListViewComponent,
  SprintLinkListViewComponent,
  UCaaSListViewComponent,
  WfListViewComponent,
  ListViewComponent,
  MssEmailTeamComponent,
  H5FolderComponent,
  CsgErrorPageComponent,
  GenerateICSComponent,
  

  // Templates
  CustomerTemplateComponent,
  RequestorTemplateComponent,
  SalesTemplateComponent,
  ScheduleTemplateComponent,
  LookupM5Component,
  AvailableViewsComponent,
  LookupSiteComponent,
  EscalationTemplateComponent,
  EventHistoryTemplateComponent,
  ActivatorsTemplateComponent,
  ReviewerTemplateComponent,
  LookupH1Component,
  LookupH6Component,
  ContactListComponent,
  OrderNoteTemplateComponent,
  CalendarViewComponent,
  LookupOpenSlotComponent,
  LookupEventHistoryComponent,
  BillingDispatchComponent,
  BillingDispatchDetailComponent,
  AdditionalCustomerChargeComponent,
  //NccoOrderDetailsComponent
} from "./index";

import {
  MaskDirective,
  TextValidatorDirective,
  ApiHelperService,
  Helper,

  RoutingStateService,
  TimeoutInterceptor,
  DEFAULT_TIMEOUT
} from "../shared/index";

import { UserResolver } from "../shared/user-resolver";
import { AuthGuard } from "../shared/auth.guard";
import { AdminAuthGuard } from "../shared/admin-auth.guard";
import { EventAuthGuard } from "../shared/event-auth.guard";

// import Services
import {
  UserService,
  PeopleSoftInterfaceViewService,
  NRMBPMInterfaceViewService,
  DedicatedCustomerService,
  EventTypeService,
  NavLinkService,
  MDSMACActivityService,
  ServiceDeliveryService,
  ServiceAssuranceSiteSupportService,
  SpecialProjectService,
  SprintHolidayService,
  TelcoService,
  MDS3rdPartyServiceService,
  MDS3rdPartyVendorService,
  MDSServiceTypeService,
  ServiceTierService,
  EnhncSrvcService,
  MDSActivityTypeService,
  EventStatusService,
  MDSFastTrackTypeService,
  ProductTypeService,
  OrderTypeService,
  OrderSubTypeService,
  GroupService,
  PlatformService,
  RegionService,
  RedesignCategoryService,
  RedesignTypeService,
  StatusService,
  FedlineOrderTypeService,
  SetSlasService,
  CurrencyListService,
  getUnlockItemsViewService,
  SearchService,
  WorldHolidayService,
  CountryService,
  CityService,
  getCancelOrdrViewService,
  SetPreferenceService,
  AccessCitySiteService,
  VendorService,
  ModalService,
  EventIntervalService,
  DeviceManufacturerService,
  DeviceModelService,
  CCDBypassService,
  OrderActionService,
  CurrencyFileService,
  CustomerUserProfileService,
  IPVersionService,
  MDSNetworkActivityTypeService,
  QualificationService,
  AdEventService,
  EventViewsService,
  EscalationReasonService,
  ActivityLocaleService,
  MplsAccessBandwidthService,
  MplsActivityTypeService,
  MplsEventTypeService,
  VpnPlatformTypeService,
  VasTypeService,
  MultiVrfReqService,
  MplsMigrationTypeService,
  WorkflowService,
  MplsEventService,
  WholesalePartnerService,
  MplsEventAccessTagService,
  NgvnEventService,
  EventAsnToUserService,
  MnsOfferingRouterService,
  MnsPerformanceReportingService,
  MnsRoutingTypeService,
  UcaasActivityTypeService,
  UcaasBillActivityService,
  UcaasPlanTypeService,
  UcaasProdTypeService,
  EventLockService,
  EventHistoryService,
  ActivatorsService,
  MenuService,
  MdsSiteInformation,
  MDSNetworkInformationService,
  EventDeviceMgmtService,
  UcaasEventService,
  FedlineEventService,
  MdsEventService,
  OrderNoteService,
  NccoOrderService,
  CalendarService,
  RedesignService,
  CptCustomerTypeService,
  CptHostManagedService,
  CptManagedAuthProdService,
  CptMdsSupportTierService,
  CptMvsProdTypeService,
  CptPlanSrvcTierService,
  CptPlanSrvcTypeService,
  CptPrimSecondaryTransportService,
  CptPrimSiteService,
  CptProvTypeService,
  CptService,
  RedesignDocService,
  RedesignCustBypassService,
  RedesignWorkflowService,
  OdieRspnInfoService,
  RedesignRecLockService,
  BillingDispatchService,
  BillingDispatchParameterService,
  NRMService,
  CircuitService,
  FormControlValidationService,
  AdditionalCustomerChargeService,
  CcdService,
  WorkGroupService,
  StdiReasonService,
  SystemConfigService,
  CompleteOrderService,
  CacheAdminService,
  AdminSupportService,
  ContactDetailService
} from "../services/index";

import { routes } from "./routes";
import { NgxSpinnerModule } from "ngx-spinner";
import {
  ModalComponent,
  DisableControlDirective,
  MatchHeightDirective,
  TrimValueAccessorDirective
} from "../directives";
import { CommonModule, DatePipe } from "@angular/common";
import { CancelComponent } from "./cancel/cancel.component";
import { PageNotFoundComponent } from "./page-not-found/page-not-found.component";
import { XnciWfmAssignComponent } from './tools/xnci-wfm-assign/xnci-wfm-assign.component';
import { GomWfmAssignComponent } from './tools/gom-wfm-assign/gom-wfm-assign.component';
import { SharedModule } from "./shared/shared-module";

import { AdditionalCostsFormComponent } from './shared/additional-costs-form/additional-costs-form.component';
import { FileSizePipe } from '../shared/pipe/file-size.pipe';
import { CompleteOrderEventComponent } from './admin/complete-order-event/complete-order-event.component';
import { CacheAdminComponent } from './admin/cache-admin/cache-admin.component';
import { AdminSupportComponent } from "./support/admin-support.component";

export function loadUserData(usrSrvc: UserService) {
  return () => {
    return usrSrvc.getLoggedInUser2();
  }
}

@NgModule({
  declarations: [
    // Directives
    DisableControlDirective,
    MatchHeightDirective,
    TrimValueAccessorDirective,

    AppComponent,
    NavMenuComponent,
    NavHeaderComponent,
    NavFooterComponent,
    NavLinksComponent,
    SideNavComponent,
    HomeComponent,
    UserComponent,
    NRMBPMInterfaceViewComponent,
    MaskDirective,
    TextValidatorDirective,
    PeopleSoftInterfaceViewComponent,
    DedicatedCustomerComponent,
    EventTypeComponent,
    AuthorizeComponent,
    SearchComponent,
    AdvancedSearchComponent,
    SearchResultComponent,
    MDSMACActivityComponent,
    ServiceDeliveryComponent,
    ServiceAssuranceSiteSupportComponent,
    SpecialProjectComponent,
    SprintHolidayComponent,
    TelcoComponent,
    MDS3rdPartyServiceComponent,
    MDS3rdPartyVendorComponent,
    ServiceTierComponent,
    EnhncSrvcComponent,
    ManageUsersComponent,
    XnciMsSlaComponent,
    CurrencyListComponent,
    UnlockItemsComponent,
    WorldHolidayComponent,
    CancelOrdrComponent,
    SetPreferenceComponent,
    FastTrackAvailabilityComponent,
    VendorManagementComponent,
    ModalComponent,
    EventIntervalComponent,
    VendorModelComponent,
    FedlineAvailabilityComponent,
    XnciRegionComponent,
    CCDBypassComponent,
    CcdChangeComponent,
    CurrencyFileComponent,
    CustomerUserProfileComponent,
    UcaasComponent,
    AccessDeliveryComponent,
    AccessDeliveryFormComponent,
    SiptComponent,
    SiptFormComponent,
    SorryComponent,
    UserFinderComponent,
    QualificationComponent,
    QualificationFormComponent,
    QualificationViewComponent,
    SampleEventComponent,
    FedlineComponent,
    MdsComponent,
    MplsComponent,
    MplsFormComponent,
    NgvnComponent,
    SprintLinkComponent,
    SprintLinkFormComponent,
    CreateViewComponent,
    FedlineFormComponent,
    MdsFormComponent,
    NgvnFormComponent,
    UcaasFormComponent,
    WfCalendarComponent,
    SprintLinkCalendarComponent,
    NccoOrderFormComponent,
    NccoOrderComponent,
    MssViewEngagementsComponent,
    MssProductTypesComponent,
    NgvnCalendarComponent,
    SiptCalendarComponent,
    UCaaSCalendarComponent,
    MplsVasCalendarComponent,
    MplsCalendarComponent,
    MdsftCalendarComponent,
    MdsCalendarComponent,
    NetworkIntlCalendarComponent,
    MssNewEngagementComponent,
    ADBroadbandCalendarComponent,
    ADNarrowbandCalendarComponent,
    ADGovernmentCalendarComponent,
    ADInternationalCalendarComponent,
    ADTMTCalendarComponent,
    ESCalendarComponent,
    CpeClliComponent,
    CpeClliFormComponent,
    ViewRedesignComponent,
    NewRedesignComponent,
    CustomerBypassComponent,
    CptAssignmentComponent,
    CptFormComponent,
    CptReportComponent,
    CptReturnComponent,
    CptSearchComponent,
    CptViewComponent,
    FedlineCalendarComponent,
    ADBroadbandListViewComponent,
    ADGovernmentListViewComponent,
    ADInternationalListViewComponent,
    ADNarrowbandListViewComponent,
    ADTMTListViewComponent,
    ESListViewComponent,
    FedlineListViewComponent,
    MdsListViewComponent,
    MdsftListViewComponent,
    NetworkIntlListViewComponent,
    MplsListViewComponent,
    MplsVasListViewComponent,
    NgvnListViewComponent,
    SiptListViewComponent,
    SprintLinkListViewComponent,
    UCaaSListViewComponent,
    WfListViewComponent,
    ListViewComponent,
    MssEmailTeamComponent,
    CancelComponent,
    H5FolderComponent,
    CsgErrorPageComponent,

    // Templates
    CustomerTemplateComponent,
    RequestorTemplateComponent,
    SalesTemplateComponent,
    ScheduleTemplateComponent,
    LookupM5Component,
    AvailableViewsComponent,
    LookupSiteComponent,
    EscalationTemplateComponent,
    EventHistoryTemplateComponent,
    ActivatorsTemplateComponent,
    ReviewerTemplateComponent,
    LookupH1Component,
    LookupH6Component,
    ContactListComponent,
    OrderNoteTemplateComponent,
    CalendarViewComponent,
    LookupOpenSlotComponent,
    LookupEventHistoryComponent,
    PageNotFoundComponent,
    BillingDispatchComponent,
    BillingDispatchDetailComponent,
    XnciWfmAssignComponent,
    GomWfmAssignComponent,
    AdditionalCustomerChargeComponent,
    AdditionalCostsFormComponent,
    GenerateICSComponent,
    FileSizePipe,
    CompleteOrderEventComponent,
    CacheAdminComponent,
    AdminSupportComponent
  ],
  imports: [
    //BrowserModule.withServerTransition({ appId: 'ng-cli-universal' }),
    AppDxtremeModule,
    RouterModule.forRoot(routes, {
      useHash: false,
      onSameUrlNavigation: "reload",
      scrollPositionRestoration: 'enabled'
    }),
    HttpClientModule,
    FormsModule,
    ReactiveFormsModule,
    NgxSpinnerModule,
    BrowserAnimationsModule,
    AppMaterialModule,
    BrowserModule,
    CommonModule,
    MatDialogModule,
    SharedModule
  ],
  providers: [
    [{ provide: HTTP_INTERCEPTORS, useClass: TimeoutInterceptor, multi: true }],
    [{ provide: DEFAULT_TIMEOUT, useValue: 120000 }],
    //Pipes
    FileSizePipe,
    DatePipe,
    AuthGuard,
    AdminAuthGuard,
    EventAuthGuard,
    Helper,
    UserResolver,
    NavLinkService,
    UserService,
    NRMBPMInterfaceViewService,
    ApiHelperService,
    DedicatedCustomerService,
    EventTypeService,
    MDSMACActivityService,
    ServiceDeliveryService,
    ServiceAssuranceSiteSupportService,
    SpecialProjectService,
    SprintHolidayService,
    TelcoService,
    ServiceTierService,
    MDS3rdPartyVendorService,
    MDS3rdPartyServiceService,
    MDSServiceTypeService,
    EnhncSrvcService,
    MDSActivityTypeService,
    EventStatusService,
    MDSFastTrackTypeService,
    ProductTypeService,
    OrderTypeService,
    OrderSubTypeService,
    GroupService,
    PlatformService,
    RegionService,
    RedesignCategoryService,
    RedesignTypeService,
    StatusService,
    FedlineOrderTypeService,
    SetSlasService,
    CurrencyListService,
    getUnlockItemsViewService,
    SearchService,
    WorldHolidayService,
    CountryService,
    CityService,
    getCancelOrdrViewService,
    SetPreferenceService,
    AccessCitySiteService,
    VendorService,
    ModalService,
    EventIntervalService,
    DeviceManufacturerService,
    DeviceModelService,
    CCDBypassService,
    OrderActionService,
    CurrencyFileService,
    CustomerUserProfileService,
    IPVersionService,
    MDSNetworkActivityTypeService,
    QualificationService,
    AdEventService,
    EventViewsService,
    EscalationReasonService,
    ActivityLocaleService,
    MplsAccessBandwidthService,
    MplsActivityTypeService,
    MplsEventTypeService,
    MplsMigrationTypeService,
    MultiVrfReqService,
    VasTypeService,
    VpnPlatformTypeService,
    MplsEventService,
    WholesalePartnerService,
    WorkflowService,
    MplsEventAccessTagService,
    NgvnEventService,
    EventAsnToUserService,
    MnsOfferingRouterService,
    MnsPerformanceReportingService,
    MnsRoutingTypeService,
    UcaasActivityTypeService,
    UcaasBillActivityService,
    UcaasPlanTypeService,
    UcaasProdTypeService,
    EventLockService,
    EventHistoryService,
    ActivatorsService,
    MenuService,
    MdsSiteInformation,
    MDSNetworkInformationService,
    EventDeviceMgmtService,
    UcaasEventService,
    FedlineEventService,
    MdsEventService,
    OrderNoteService,
    NccoOrderService,
    CalendarService,
    RedesignService,
    CptCustomerTypeService,
    CptHostManagedService,
    CptManagedAuthProdService,
    CptMdsSupportTierService,
    CptMvsProdTypeService,
    CptPlanSrvcTierService,
    CptPlanSrvcTypeService,
    CptPrimSecondaryTransportService,
    CptPrimSiteService,
    CptProvTypeService,
    CptService,
    RedesignDocService,
    RedesignCustBypassService,
    RedesignWorkflowService,
    OdieRspnInfoService,
    RedesignRecLockService,
    BillingDispatchService,
    BillingDispatchParameterService,
    NRMService,
    CircuitService,
    FormControlValidationService,
    AdditionalCustomerChargeService,
    CcdService,
    WorkGroupService,
    StdiReasonService,
    SystemConfigService,
    RoutingStateService,
    CompleteOrderService,
    CacheAdminService,
    ContactDetailService,
    {
      provide: APP_INITIALIZER,
      useFactory: loadUserData,
      multi: true,
      deps: [UserService]
    }    
    //{
    //  provide: 'externalUrlRedirectResolver',
    //  useValue: (route: ActivatedRouteSnapshot, state: RouterStateSnapshot) => {
    //    window.location.href = (route.data as any).externalUrl;
    //  }
    //}
  ],
  bootstrap: [AppComponent],
  schemas: [CUSTOM_ELEMENTS_SCHEMA]
})
export class AppModule {}
